#!/usr/local/bin/python
from PoP import *

pop = PoP()
Number_ = Atom('number')
Integer_ = Atom('integer')
Float_ = Atom('float')
String_ = Atom('string')
Atom_ = Atom('atom')
Atom1_ = Atom('atom1')
Atom2_ = Atom('atom2')
List_ = Atom('list')
Clause_ = Atom('clause')
Nil_ = Atom('nil')
Equal = Atom('equal')
X = Variable('x')

# for p in pop.builtins():
	# pop.spy(p)
# for p in pop.userdefs():
	# pop.spy(p)
# pop.trace()

assert pop.inquire(Number_(3)) <> None
assert pop.inquire(Number_(3.4)) <> None
assert pop.inquire(Number_('abc')) == None
assert pop.inquire(Number_(Atom('a'))) == None
assert pop.inquire(Number_(Atom('a', 3))) == None
assert pop.inquire(Number_([1, 2])) == None
assert pop.inquire(Number_(Clause(Atom('a')))) == None
assert pop.inquire(Number_([])) == None
assert pop.inquire(Number_(Variable())) == None
assert pop.inquire(Equal(X, 3), Number_(X)) <> None
assert pop.inquire(Equal(X, 3.4), Number_(X)) <> None

assert pop.inquire(Integer_(3)) <> None
assert pop.inquire(Integer_(3.4)) == None
assert pop.inquire(Integer_('abc')) == None
assert pop.inquire(Integer_(Atom('a'))) == None
assert pop.inquire(Integer_(Atom('a', 3))) == None
assert pop.inquire(Integer_([1, 2])) == None
assert pop.inquire(Integer_(Clause(Atom('a')))) == None
assert pop.inquire(Integer_([])) == None
assert pop.inquire(Integer_(Variable())) == None
assert pop.inquire(Equal(X, 3), Integer_(X)) <> None

assert pop.inquire(Float_(3)) == None
assert pop.inquire(Float_(3.4)) <> None
assert pop.inquire(Float_('abc')) == None
assert pop.inquire(Float_(Atom('a'))) == None
assert pop.inquire(Float_(Atom('a', 3))) == None
assert pop.inquire(Float_([1, 2])) == None
assert pop.inquire(Float_(Clause(Atom('a')))) == None
assert pop.inquire(Float_([])) == None
assert pop.inquire(Float_(Variable())) == None
assert pop.inquire(Equal(X, 3.4), Float_(X)) <> None

assert pop.inquire(String_(3)) == None
assert pop.inquire(String_(3.4)) == None
assert pop.inquire(String_('abc')) <> None
assert pop.inquire(String_(Atom('a'))) == None
assert pop.inquire(String_(Atom('a', 3))) == None
assert pop.inquire(String_([1, 2])) == None
assert pop.inquire(String_(Clause(Atom('a')))) == None
assert pop.inquire(String_([])) == None
assert pop.inquire(String_(Variable())) == None
assert pop.inquire(Equal(X, 'abc'), String_(X)) <> None

assert pop.inquire(Atom_(3)) == None
assert pop.inquire(Atom_(3.4)) == None
assert pop.inquire(Atom_('abc')) == None
assert pop.inquire(Atom_(Atom('a'))) <> None
assert pop.inquire(Atom_(Atom('a', 3))) <> None
assert pop.inquire(Atom_([1, 2])) == None
assert pop.inquire(Atom_(Clause(Atom('a')))) == None
assert pop.inquire(Atom_([])) == None
assert pop.inquire(Atom_(Variable())) == None
assert pop.inquire(Equal(X, Atom('a')), Atom_(X)) <> None
assert pop.inquire(Equal(X, Atom('a', 3)), Atom_(X)) <> None

assert pop.inquire(Atom1_(3)) == None
assert pop.inquire(Atom1_(3.4)) == None
assert pop.inquire(Atom1_('abc')) == None
assert pop.inquire(Atom1_(Atom('a'))) <> None
assert pop.inquire(Atom1_(Atom('a', 3))) == None
assert pop.inquire(Atom1_([1, 2])) == None
assert pop.inquire(Atom1_(Clause(Atom('a')))) == None
assert pop.inquire(Atom1_([])) == None
assert pop.inquire(Atom1_(Variable())) == None
assert pop.inquire(Equal(X, Atom('a')), Atom1_(X)) <> None

assert pop.inquire(Atom2_(3)) == None
assert pop.inquire(Atom2_(3.4)) == None
assert pop.inquire(Atom2_('abc')) == None
assert pop.inquire(Atom2_(Atom('a'))) == None
assert pop.inquire(Atom2_(Atom('a', 3))) <> None
assert pop.inquire(Atom2_([1, 2])) == None
assert pop.inquire(Atom2_(Clause(Atom('a')))) == None
assert pop.inquire(Atom2_([])) == None
assert pop.inquire(Atom2_(Variable())) == None
assert pop.inquire(Equal(X, Atom('a', 3)), Atom2_(X)) <> None

assert pop.inquire(List_(3)) == None
assert pop.inquire(List_(3.4)) == None
assert pop.inquire(List_('abc')) == None
assert pop.inquire(List_(Atom('a'))) == None
assert pop.inquire(List_(Atom('a', 3))) == None
assert pop.inquire(List_([1, 2])) <> None
assert pop.inquire(List_(Clause(Atom('a')))) == None
assert pop.inquire(List_([])) == None
assert pop.inquire(List_(Variable())) == None
assert pop.inquire(Equal(X, [1, 2]), List_(X)) <> None

assert pop.inquire(Clause_(3)) == None
assert pop.inquire(Clause_(3.4)) == None
assert pop.inquire(Clause_('abc')) == None
assert pop.inquire(Clause_(Atom('a'))) == None
assert pop.inquire(Clause_(Atom('a', 3))) == None
assert pop.inquire(Clause_([1, 2])) == None
assert pop.inquire(Clause_(Clause(Atom('a')))) <> None
assert pop.inquire(Clause_([])) == None
assert pop.inquire(Clause_(Variable())) == None
assert pop.inquire(Equal(X, Clause(Atom('a'))), Clause_(X)) <> None

assert pop.inquire(Nil_(3)) == None
assert pop.inquire(Nil_(3.4)) == None
assert pop.inquire(Nil_('abc')) == None
assert pop.inquire(Nil_(Atom('a'))) == None
assert pop.inquire(Nil_(Atom('a', 3))) == None
assert pop.inquire(Nil_([1, 2])) == None
assert pop.inquire(Nil_(Clause(Atom('a')))) == None
assert pop.inquire(Nil_([])) <> None
assert pop.inquire(Nil_(Variable())) == None
assert pop.inquire(Equal(X, []), Nil_(X)) <> None
