#!/usr/local/bin/python
from PoP import *

pop = PoP()
Eq = Atom('eq')
Ne = Atom('ne')
Lt = Atom('lt')
Le = Atom('le')
Gt = Atom('gt')
Ge = Atom('ge')
Add = Atom('add')

# for p in pop.builtins():
	# pop.spy(p)
# for p in pop.userdefs():
	# pop.spy(p)
# pop.trace()

assert pop.inquire(Eq(3, 3)) <> None
assert pop.inquire(Eq(2, 3)) == None
assert pop.inquire(Eq(3, Add(1, 2))) <> None
assert pop.inquire(Eq(Add(1, 2), 3)) <> None
assert pop.inquire(Eq(Add(1, 2), Add(2, 1))) <> None
assert pop.inquire(Eq('b', 'b')) <> None
assert pop.inquire(Eq('a', 'b')) == None

assert pop.inquire(Ne(3, 3)) == None
assert pop.inquire(Ne(2, 3)) <> None
assert pop.inquire(Ne(3, Add(2, 4))) <> None
assert pop.inquire(Ne(Add(2, 4), 3)) <> None
assert pop.inquire(Ne(Add(2, 4), Add(2, 3))) <> None
assert pop.inquire(Ne('b', 'b')) == None
assert pop.inquire(Ne('a', 'b')) <> None

assert pop.inquire(Lt(3, 3)) == None
assert pop.inquire(Lt(2, 3)) <> None
assert pop.inquire(Lt(3, 1)) == None
assert pop.inquire(Lt(3, Add(2, 4))) <> None
assert pop.inquire(Lt(Add(2, 4), 7)) <> None
assert pop.inquire(Lt(Add(2, 3), Add(2, 4))) <> None
assert pop.inquire(Lt('b', 'b')) == None
assert pop.inquire(Lt('a', 'b')) <> None
assert pop.inquire(Lt('b', 'a')) == None

assert pop.inquire(Le(3, 3)) <> None
assert pop.inquire(Le(2, 3)) <> None
assert pop.inquire(Le(3, 1)) == None
assert pop.inquire(Le(3, Add(2, 4))) <> None
assert pop.inquire(Le(Add(2, 4), 7)) <> None
assert pop.inquire(Le(Add(2, 3), Add(2, 4))) <> None
assert pop.inquire(Le('b', 'b')) <> None
assert pop.inquire(Le('a', 'b')) <> None
assert pop.inquire(Le('b', 'a')) == None

assert pop.inquire(Gt(3, 3)) == None
assert pop.inquire(Gt(2, 3)) == None
assert pop.inquire(Gt(3, 1)) <> None
assert pop.inquire(Gt(7, Add(2, 4))) <> None
assert pop.inquire(Gt(Add(2, 4), 5)) <> None
assert pop.inquire(Gt(Add(2, 3), Add(2, 1))) <> None
assert pop.inquire(Gt('b', 'b')) == None
assert pop.inquire(Gt('a', 'b')) == None
assert pop.inquire(Gt('b', 'a')) <> None

assert pop.inquire(Ge(3, 3)) <> None
assert pop.inquire(Ge(2, 3)) == None
assert pop.inquire(Ge(3, 1)) <> None
assert pop.inquire(Ge(7, Add(2, 4))) <> None
assert pop.inquire(Ge(Add(2, 4), 5)) <> None
assert pop.inquire(Ge(Add(2, 3), Add(2, 1))) <> None
assert pop.inquire(Ge('b', 'b')) <> None
assert pop.inquire(Ge('a', 'b')) == None
assert pop.inquire(Ge('b', 'a')) <> None
