#!/usr/local/bin/python
from PoP import *

pop = PoP()
Is = Atom('is')
Integer_ = Atom('integer')
Float_ = Atom('float')
Abs_ = Atom('abs')
Add_ = Atom('add')
Sub_ = Atom('sub')
Mul_ = Atom('mul')
Div_ = Atom('div')
Idiv_ = Atom('idiv')
Mod_ = Atom('mod')

x = Variable('x')

# for p in pop.builtins():
	# pop.spy(p)
# for p in pop.userdefs():
	# pop.spy(p)
# pop.trace()

assert pop.inquire(Is(x, Integer_(3)))['x'].value() == int(3)
assert pop.inquire(Is(x, Integer_(3.4)))['x'].value() == int(3.4)
assert pop.inquire(Is(x, Integer_('abc'))) == None

assert pop.inquire(Is(x, Float_(3)))['x'].value() == float(3)
assert pop.inquire(Is(x, Float_(3.4)))['x'].value() == float(3.4)
assert pop.inquire(Is(x, Float_('abc'))) == None

assert pop.inquire(Is(x, Abs_(3)))['x'].value() == abs(3)
assert pop.inquire(Is(x, Abs_(-3)))['x'].value() == abs(-3)
assert pop.inquire(Is(x, Abs_('abc'))) == None

assert pop.inquire(Is(x, Add_(5, 3)))['x'].value() == 5 + 3
assert pop.inquire(Is(x, Add_('abc', 'def'))) == None

assert pop.inquire(Is(x, Sub_(5, 3)))['x'].value() == 5 - 3
assert pop.inquire(Is(x, Sub_('abc', 'def'))) == None

assert pop.inquire(Is(x, Mul_(5, 3)))['x'].value() == 5 * 3
assert pop.inquire(Is(x, Mul_('abc', 'def'))) == None

assert pop.inquire(Is(x, Div_(5, 3)))['x'].value() == 5.0 / 3.0
assert pop.inquire(Is(x, Div_('abc', 'def'))) == None

assert pop.inquire(Is(x, Idiv_(5, 3)))['x'].value() == 5 / 3
assert pop.inquire(Is(x, Idiv_('abc', 'def'))) == None

assert pop.inquire(Is(x, Mod_(5, 3)))['x'].value() == 5 % 3
assert pop.inquire(Is(x, Mod_('abc', 'def'))) == None
