#!/usr/local/bin/python
from PoP import *

pop = PoP()
p0 = Atom('p0')
p1 = Atom('p1')
q0 = Atom('q0')

# for p in pop.builtins():
	# pop.spy(p)
# for p in pop.userdefs():
	# pop.spy(p)
# pop.trace()

assert pop.userdefs() == []
pop.assertz(p0)
assert pop.userdefs() == ['p0']
assert len(pop.userpred('p0')) == 1
assert pop.userpred('p0')[0].head().name() == 'p0'
assert pop.userpred('p0')[0].body() == []
pop.assertz(p0, p1)
assert pop.userdefs() == ['p0']
assert len(pop.userpred('p0')) == 2
assert pop.userpred('p0')[1].head().name() == 'p0'
assert len(pop.userpred('p0')[1].body()) == 1
assert pop.userpred('p0')[1].body()[0].name() == 'p1'
pop.assertz(q0)
assert pop.userdefs() == ['p0', 'q0']
assert len(pop.userpred('q0')) == 1
assert pop.userpred('q0')[0].head().name() == 'q0'
assert pop.userpred('q0')[0].body() == []
pop.abolish('p0')
assert pop.userdefs() == ['q0']
pop.abolish('q0')
assert pop.userdefs() == []
